import javax.jms.*;
import javax.naming.*;
import java.util.Properties;

public class TxSender {

    public static void main(String[] args) {		
        try {
            int count = 1000;
            int abs_count = 0;
            String connectionUrl = "amqp://guest:guest@clientid/test?brokerlist='tcp://localhost:5672;tcp://localhost:10000'";
            String address = "my-queUE; {create:always}";

            Properties props = new Properties();
            props.setProperty("java.naming.factory.initial", "org.apache.qpid.jndi.PropertiesFileInitialContextFactory");
            props.setProperty("connectionfactory.host", connectionUrl);
            props.setProperty("destination.address", address);

            Context ctx = new InitialContext(props);
            ConnectionFactory factory = (ConnectionFactory) ctx.lookup("host");
            Destination target = (Destination) ctx.lookup("address");

            Connection conn = factory.createConnection();
            Session session = conn.createSession(true, Session.AUTO_ACKNOWLEDGE);            
            MessageProducer sender = session.createProducer(target);
            sender.setDisableMessageTimestamp(false);
            TextMessage message = session.createTextMessage();
            int sent = 0;
            int i = 0;
            int b_size=0;
            while (sent < count) {
                try {
                    //++i;
                    
                    message.setText("message-" + (i+1) + "-" + i);
                    abs_count++;
                    message.setIntProperty("abs_count",abs_count);
                    long t = System.currentTimeMillis();
                    message.setLongProperty("time",t);
                    sender.send(message);
                    System.out.println("Sending message: " + message.getText() + " time: " + t + " abs_count: " + abs_count);
                    b_size++;                    

                    Thread.sleep(1*10);
                    
                    if ( (i % 100 == 99) || (i >= (count-1)) ) {
                        session.commit();
                        sent = i+1;
                        System.out.println("Committed " + sent);
                        System.out.println("B_size " + b_size);
                        b_size=0;
                    }
                    
                    i++;
                } catch (Exception e) {
                    e.printStackTrace();
                    System.out.println("Creating new session; transaction rolledback due to exception: " + e.toString());
                    System.out.println("Failover happened at : " + System.currentTimeMillis());
                    session = conn.createSession(true, Session.AUTO_ACKNOWLEDGE);
                    sender = session.createProducer(target);
                    sender.setDisableMessageTimestamp(false);
                    message = session.createTextMessage();
                    i = sent;
                    b_size=0;
                }
            }
        } catch (Exception e) {
            System.out.println("Exception occurred: " + e.toString());
            e.printStackTrace();
        }
    }
}


